'Diamonds puzzle game for Maximite
'MM Basic v3.2 , Game v1.1
'Date : 2012 04 21
'Fabrice Muller
Option Base 0

MaxLevel = 6

MapFile$ = "lvl_001.lvl"
Level_Number = 1
Sprite_W = 32
Sprite_H = 32
NbSprite = 80
First = 41
Last = 120
Dim Map_Level(15, 12)
Level_W = 15
Level_H = 12
'Specific variables for the game
NbMonsters = 0
NbDiam = 0
NbRocks = 0
Score = 0
Lives = 3
Dim DoorCase(2)
ActKey = 0
'Nunchuck Address
i2caddr = &h52
'Nunchuck buffer
Dim rdbuff(6)
'Maximum 50 rocks , 50 diamonds and 20 monsters per level !!
Dim Rocks(50, 13)
Dim Diams(50, 13)
Dim Hero(9)
Dim HeroStart(2)
Dim Monsters(20, 9)
' Diamonds Pictures Number
MaxDiamPic = 4
Dim DiamPic(MaxDiamPic)
' Rocks Pictures Number
MaxRocksPic = 4
Dim RocksPic(MaxRocksPic)
' Dynamite Pictures number
MaxDynamPic = 8
Dim DynamPic(MaxDynamPic)
' Explosion Pictures number
MaxExploPic = 8
Dim ExploPic(MaxExploPic)
' Wall Picture number
MaxWallPic = 2
Dim WallPic(MaxWallPic)
' Door Pictures number
MaxDoorPic = 8
Dim DoorPic(MaxDoorPic)
' Hero Pictures number
MaxDirectionPic = 4
Dim Hero_go_down(MaxDirectionPic)
Dim Hero_go_up(MaxDirectionPic)
Dim Hero_go_left(MaxDirectionPic)
Dim Hero_go_right(MaxDirectionPic)
Dim Hero_push_right(MaxDirectionPic)
Dim Hero_push_left(MaxDirectionPic)
' Monster Pictures number
MaxMonsterPic = 4
Dim Monster1Pic(MaxMonsterPic)
Dim Monster2Pic(MaxMonsterPic)
Monster_Type_1 = 73
Monster_Type_2 = 77
'Dynamites and Explosions coordinates and status
Dim DynCoord(3)
Dim ExplodeCoords(5,3)

' Define the picture when Hero dont move for at least 2sec
Hero_dont_move = 41
BlankCase = 110
HeroCase = 253
Game_Timer = 200
RD_Timer = 50
' The Hero get 3 Dynamite at start
Hero(5) = 3
' Controls variables
Joystick = 0
Nunchuck = 0
Keyboard = 0
' Set the controller to use
Set_Control
' ***** Main part of the game *****
Font Load "Diam.fnt" As #6
Font #6
Cls
Init_Sprites
Read_Map_File (MapFile$)
Show_Map
Init_Rocks
Init_Diamonds
Init_Hero
Init_Monster
Score = 0
Pose_Dynamite = 0
Timer = 0
Cnt_RD = 0
Dim Old_Monster(4)
n = 0
diamnb$ = ""
' ***** Main game loop *****
Do While 1
 If Timer >= Game_Timer Then
  Timer = 0
  Game_Timer_State
  Font #1
  Print @(10 , 420) "LIVES : "
  Print @(60 , 420) Lives
  Print @(100 , 420) "DIAMONDS : "
  diamnb$ = Str$(NbDiam) + " "
  Print @(170 , 420) diamnb$
  Print @(210 , 420) "DYNAMITES : "
  Print @(290 , 420) Hero(5)
  Print @(340 , 420) "SCORE : "
  Print @(380 , 420) Score
  Font #6
 EndIf
 If Cnt_RD >= RD_Timer Then
  Check_Rocks
  If Pose_Dynamite = 0 Then
   Check_Diamonds
  EndIf

  'Move the Monsters
  If NbMonsters > 0 Then
   For n = 1 To NbMonsters
    Old_Monster(1) = Monsters(n, 1)
    Old_Monster(2) = Monsters(n, 2)
    Old_Monster(3) = Monsters(n, 3)
    Old_Monster(4) = Monsters(n, 4)
    Monster_Move n
    'Show the monster at new position
    Print @((Old_Monster(1) - 1) * Sprite_W, (Old_Monster(2) - 1) * Sprite_H) Chr$(BlankCase)
    Map_Level(Old_Monster(1), Old_Monster(2)) = BlankCase
    If Monsters(n, 5) = Monster_Type_1 Then
     Monsters(n, 3) = Monsters(n, 3) + 1
     If Monsters(n, 3) > Monster1Pic(MaxMonsterPic) Then
      Monsters(n, 3) = Monster1Pic(1)
     EndIf
    Else
     Monsters(n, 3) = Monsters(n, 3) + 1
     If Monsters(n, 3) > Monster2Pic(MaxMonsterPic) Then
      Monsters(n, 3) = Monster2Pic(1)
     EndIf
    EndIf
    Print @((Monsters(n , 1) - 1) * Sprite_W, (Monsters(n , 2) - 1) * Sprite_H) Chr$(Monsters(n , 3))
    Map_Level(Monsters(n, 1), Monsters(n, 2)) = Monsters(n, 3)
    If (Monsters(n, 1) = Hero(1)) And (Monsters(n, 2) = Hero(2)) Then
     'This monster get the Hero , we die
     Hero_Killed
    EndIf
   Next n
   Check_Monster_Status
  EndIf
  Cnt_RD = 0
 EndIf
 Cnt_RD = Cnt_RD + 1
Loop
' ***** Sub Programs *****

Sub Game_Timer_State
 Local ExpCnt
 '&h80 : UP , &h81 : DOWN , &h83 : RIGHT, &h82 : LEFT , 32 : Drop a Dynamite
 If Joystick = 1 Then Joystick_Ctrl
 If Nunchuck = 1 Then Nunchuck_Ctrl
 If Keyboard = 1 Then Keyboard_Ctrl
 If ActKey = &h80 Then Hero_Move 1
 If ActKey = &h83 Then Hero_Move 2
 If ActKey = &h81 Then Hero_Move 3
 If ActKey = &h82 Then Hero_Move 4
 If (ActKey = 32) And (Pose_Dynamite = 0) And (Hero(5) > 0) Then
  Pose_Dynamite = 1
  Hero(5) = Hero(5) - 1
  DynCoord(1) = Hero(1)
  DynCoord(2) = Hero(2)
  DynCoord(3) = DynamPic(1) - 1
 EndIf
 'We check fo rexplosion
 For ExpCnt = 1 To 5
  If ExplodeCoords(ExpCnt, 3) <> 0 Then
   Show_Explosion (ExpCnt)
  EndIf
 Next ExpCnt
 'Check if we have drop a dynamite
 If Pose_Dynamite = 1 Then
  Dynamite
 EndIf
 ActKey = 0
End Sub

Sub Init_Sprites
 Local i
 'Initialise all sprites numbers
 For i = 1 To 4
  DiamPic(i) = i + 68
  RocksPic(i) = i + 64
  Hero_go_down(i) = i + 40
  Hero_go_up(i) = i + 44
  Hero_go_left(i) = i + 48
  Hero_go_right(i) = i + 52
  Hero_push_right(i) = i + 56
  Hero_push_left(i) = i + 60
  Monster1Pic(i) = i + Monster_Type_1 - 1
  Monster2Pic(i) = i + Monster_Type_2 - 1
 Next i
 For i = 1 To 8
  DynamPic(i) = i + 80
  ExploPic(i) = i + 88
  DoorPic(i) = i + 96
 Next i
 WallPic(1) = 105
 WallPic(2) = 105
 Hero(3) = 41
 For i = 1 To 5
  ExplodeCoords(i , 3) = 0
 Next i
End Sub

Sub Read_Map_File(Map_File$)
 ' Here we read the Map file
 Local CntX, CntY
 Local Starting, Stoping
 Local Tmp$
 Local LineRead$
 'Before we read a map we reset some game variables
 NbMonsters = 0
 NbDiam = 0
 NbRocks = 0
 'And we read the map
 Open Map_File$ For Input As #1
  For CntY = 1 To Level_H
   Line Input #1, LineRead$
   Starting = 1
   For CntX = 1 To Level_W
    ' Decode each line from the map
    Stoping = Instr(Starting, LineRead$, ":")
    Tmp$ = Mid$(LineRead$, Starting, Stoping - Starting)
    Map_Level(CntX, CntY) = Val(Tmp$)
    Starting = Stoping + 1
   Next CntX
  Next CntY
 Close #1
 'Get the map elements
 Get_Map_Elements
End Sub

Sub Get_Map_Elements
 ' Here we get the monsters , door , diamonds position
 Local CntX, CntY
 For CntY = 1 To Level_H
  For CntX = 1 To Level_W
   'Hero position
   If (Map_Level(CntX, CntY) >= 41) And (Map_Level(CntX, CntY) <= 64) Then
    HeroStart(1) = CntX
    HeroStart(2) = CntY
    Hero(1) = CntX
    Hero(2) = CntY
    Hero(3) = 41
   EndIf
   'Rocks position
   If (Map_Level(CntX, CntY) >= 65) And (Map_Level(CntX, CntY) <= 68) Then
    NbRocks = NbRocks + 1
    Rocks(NbRocks, 1) = CntX
    Rocks(NbRocks, 2) = CntY
    Rocks(NbRocks, 3) = Map_Level(CntX, CntY)
   EndIf
   'Diamonds position
   If (Map_Level(CntX, CntY) >= 69) And (Map_Level(CntX, CntY) <= 72) Then
    NbDiam = NbDiam + 1
    Diams(NbDiam, 1) = CntX
    Diams(NbDiam, 2) = CntY
    Diams(NbDiam, 3) = Map_Level(CntX, CntY)
   EndIf
   'Monsters position
   If (Map_Level(CntX, CntY) >= 73) And (Map_Level(CntX, CntY) <= 80) Then
    NbMonsters = NbMonsters + 1
    Monsters(NbMonsters, 1) = CntX
    Monsters(NbMonsters, 2) = CntY
    Monsters(NbMonsters, 3) = Map_Level(CntX, CntY)
    Monsters(NbMonsters, 4) = 5
    If Map_Level(CntX, CntY) < Monster_Type_2 Then
     Monsters(NbMonsters, 5) = Monster_Type_1
    Else
     Monsters(NbMonsters, 5) = Monster_Type_2
    EndIf
   EndIf
   'Exit Door position
   If (Map_Level(CntX, CntY) >= 97) And (Map_Level(CntX, CntY) <= 104) Then
    DoorCase(1) = CntX
    DoorCase(2) = CntY
   EndIf
   'Empty position
   If (Map_Level(CntX, CntY) >= 110) Then
    Map_Level(CntX, CntY) = BlankCase
   EndIf
  Next CntX
 Next CntY
End Sub

Sub Check_Rocks
 ' Check if a Rock can fall down or if he kill the Hero
 Local i
 Local OldRockDir
 'Rescan the rocks
 Rescan_Rocks
 For i = 1 To NbRocks
  'Reset Rock direction
  OldRockDir = Rocks(i, 4)
  Rocks(i, 4) = 0
  'Test for fall down
  If (Rocks(i, 10) = BlankCase) Then
   Rocks(i, 4) = 1
  EndIf
  'Test for fall left down
  If ((Rocks(i, 4) <> 1) And (Rocks(i, 12) = BlankCase) And (Rocks(i, 11) = BlankCase) And (Rocks(i, 10) >= 65) And (Rocks(i, 10) <= 72) And (Rocks(i, 10) <> HeroCase)) Then
   Rocks(i, 4) = 2
  EndIf
  'Test for fall right down
  If ((Rocks(i, 4) <> 1) And (Rocks(i, 8) = BlankCase) And (Rocks(i, 9) = BlankCase) And (Rocks(i, 10) >= 65) And (Rocks(i, 10) <= 72) And (Rocks(i, 10) <> HeroCase)) Then
   Rocks(i, 4) = 3
  EndIf
  'Draw the rock to new position if needed
  If Rocks(i, 4) <> 0 Then
   Print @((Rocks(i, 1) - 1) * Sprite_W, (Rocks(i, 2) - 1) * Sprite_H) Chr$(BlankCase)
   Map_Level(Rocks(i, 1), Rocks(i, 2)) = BlankCase
   If (Rocks(i, 4) = 1) Then
    Rocks(i, 2) = Rocks(i, 2) + 1
   EndIf
   If (Rocks(i, 4) = 2) Then
    Rocks(i, 1) = Rocks(i, 1) - 1
    Rocks(i, 2) = Rocks(i, 2) + 1
   EndIf
   If (Rocks(i, 4) = 3) Then
    Rocks(i, 1) = Rocks(i, 1) + 1
    Rocks(i, 2) = Rocks(i, 2) + 1
   EndIf
   'Set the new Rock picture
   If ((Rocks(i, 3) + 1) > RocksPic(MaxRocksPic)) Then
     Rocks(i, 3) = RocksPic(1)
   Else
     Rocks(i, 3) = Rocks(i, 3) + 1
   EndIf
   'Redraw the Rock to the new position
   Print @((Rocks(i, 1) - 1) * Sprite_W, (Rocks(i, 2) - 1) * Sprite_H) Chr$(Rocks(i, 3))
   Map_Level(Rocks(i, 1), Rocks(i, 2)) = Rocks(i, 3)
   Rescan_Rocks
  Else
   If OldRockDir <> 0 Then
    Sound 150 , 20
   EndIf
  EndIf
 Next i
End Sub

Sub Rescan_Rocks
 ' Check arround each Rocks after a Rock moving
 Local i
 For i = 1 To NbRocks
  Rocks(i, 6) = Map_Level(Rocks(i, 1), Rocks(i, 2) - 1)
  Rocks(i, 7) = Map_Level(Rocks(i, 1) + 1, Rocks(i, 2) - 1)
  Rocks(i, 8) = Map_Level(Rocks(i, 1) + 1, Rocks(i, 2))
  Rocks(i, 9) = Map_Level(Rocks(i, 1) + 1, Rocks(i, 2) + 1)
  Rocks(i, 10) = Map_Level(Rocks(i, 1), Rocks(i, 2) + 1)
  Rocks(i, 11) = Map_Level(Rocks(i, 1) - 1, Rocks(i, 2) + 1)
  Rocks(i, 12) = Map_Level(Rocks(i, 1) - 1, Rocks(i, 2))
  Rocks(i, 13) = Map_Level(Rocks(i, 1) - 1, Rocks(i, 2) - 1)
 Next i
End Sub

Sub Rescan_Monsters( Monster_Num )
 ' Check arround the Monster and record the elements
 Local i
 Monsters(Monster_Num, 6) = Map_Level(Monsters(Monster_Num, 1), Monsters(Monster_Num, 2) - 1)
 Monsters(Monster_Num, 7) = Map_Level(Monsters(Monster_Num, 1) + 1, Monsters(Monster_Num, 2))
 Monsters(Monster_Num, 8) = Map_Level(Monsters(Monster_Num, 1), Monsters(Monster_Num, 2) + 1)
 Monsters(Monster_Num, 9) = Map_Level(Monsters(Monster_Num, 1) - 1, Monsters(Monster_Num, 2))
End Sub

Sub Check_Diamonds
 'Check if a Diamond can fall down
 Local i
 Local OldDiamDir
 'Rescan the rocks
 Rescan_Diamonds
 For i = 1 To NbDiam
  'Reset Diamond direction
  OldDiamDir = Diams(i , 4)
  Diams(i, 4) = 0
  'Test for fall down
  If (Diams(i, 10) = BlankCase) Then
   Diams(i, 4) = 1
  EndIf
  'Test for fall left down
  If ((Diams(i, 4) <> 1) And (Diams(i, 12) = BlankCase) And (Diams(i, 11) = BlankCase) And (Diams(i, 10) >= 65) And (Diams(i, 10) <= 72) And (Diams(i, 10) <> HeroCase)) Then
   Diams(i, 4) = 2
  EndIf
  'Test for fall right down
  If ((Diams(i, 4) <> 1) And (Diams(i, 8) = BlankCase) And (Diams(i, 9) = BlankCase) And (Diams(i, 10) >= 65) And (Diams(i, 10) <= 72) And (Diams(i, 10) <> HeroCase)) Then
   Diams(i, 4) = 3
  EndIf
  'Draw the Diamond to new position if needed
  If Diams(i, 4) <> 0 Then
   Print @((Diams(i, 1) - 1) * Sprite_W, (Diams(i, 2) - 1) * Sprite_H) Chr$(BlankCase)
   Map_Level(Diams(i, 1), Diams(i, 2)) = BlankCase
   If (Diams(i, 4) = 1) Then
    Diams(i, 2) = Diams(i, 2) + 1
   EndIf
   If (Diams(i, 4) = 2) Then
    Diams(i, 1) = Diams(i, 1) - 1
    Diams(i, 2) = Diams(i, 2) + 1
   EndIf
   If (Diams(i, 4) = 3) Then
    Diams(i, 1) = Diams(i, 1) + 1
    Diams(i, 2) = Diams(i, 2) + 1
   EndIf
   'Set the new Diamond picture
   If ((Diams(i, 3) + 1) > DiamPic(MaxDiamPic)) Then
    Diams(i, 3) = DiamPic(1)
   Else
    Diams(i, 3) = Diams(i, 3) + 1
   EndIf
   'Redraw the Diamonds to the new position
   Print @((Diams(i, 1) - 1) * Sprite_W, (Diams(i, 2) - 1) * Sprite_H) Chr$(Diams(i, 3))
   Map_Level(Diams(i, 1), Diams(i, 2)) = Diams(i, 3)
   Rescan_Diamonds
  Else
   If OldDiamDir <> 0 Then
    Sound 800 , 20
   EndIf
  EndIf
 Next i
End Sub

Sub Rescan_Diamonds
 ' Check arround each Diamonds after a Diamond moving
 Local i
 If Pose_Dynamite = 1 Then
  Exit Sub
 EndIf
 For i = 1 To NbDiam
  Diams(i, 6) = Map_Level(Diams(i, 1), Diams(i, 2) - 1)
  Diams(i, 7) = Map_Level(Diams(i, 1) + 1, Diams(i, 2) - 1)
  Diams(i, 8) = Map_Level(Diams(i, 1) + 1, Diams(i, 2))
  Diams(i, 9) = Map_Level(Diams(i, 1) + 1, Diams(i, 2) + 1)
  Diams(i, 10) = Map_Level(Diams(i, 1), Diams(i, 2) + 1)
  Diams(i, 11) = Map_Level(Diams(i, 1) - 1, Diams(i, 2) + 1)
  Diams(i, 12) = Map_Level(Diams(i, 1) - 1, Diams(i, 2))
  Diams(i, 13) = Map_Level(Diams(i, 1) - 1, Diams(i, 2) - 1)
 Next i
End Sub

Sub Init_Rocks
 ' Initialise the Rocks status at start from level
 Dim i, j, k
 NbRocks = 0
 For i = 1 To Level_W
  For j = 1 To Level_H
  'we test if we have a rock here
   If (Map_Level(i, j) >= RocksPic(1)) And (Map_Level(i, j) <= RocksPic(MaxRocksPic)) Then
    NbRocks = NbRocks + 1
    Rocks(NbRocks, 1) = i
    Rocks(NbRocks, 2) = j
    Rocks(NbRocks, 3) = Map_Level(i, j)
    Rocks(NbRocks, 4) = 0
    Rocks(NbRocks, 5) = 0
    Rocks(NbRocks, 6) = Map_Level(i, j - 1)
    Rocks(NbRocks, 7) = Map_Level(i + 1, j - 1)
    Rocks(NbRocks, 8) = Map_Level(i + 1, j)
    Rocks(NbRocks, 9) = Map_Level(i + 1, j + 1)
    Rocks(NbRocks, 10) = Map_Level(i, j + 1)
    Rocks(NbRocks, 11) = Map_Level(i - 1, j + 1)
    Rocks(NbRocks, 12) = Map_Level(i - 1, j)
    Rocks(NbRocks, 13) = Map_Level(i - 1, j - 1)
   EndIf
  Next j
 Next i
End Sub

Sub Init_Diamonds
 'Initialise the Diamonds status at start from level
 Local i, j, k
 If Pose_Dynamite = 1 Then
  Exit Sub
 EndIf
 NbDiam = 0
 For i = 1 To Level_W
  For j = 1 To Level_H
  'we test if we have a Diamond here
   If (Map_Level(i, j) >= DiamPic(1)) And (Map_Level(i, j) <= DiamPic(MaxDiamPic)) Then
    NbDiam = NbDiam + 1
    Diams(NbDiam, 1) = i
    Diams(NbDiam, 2) = j
    Diams(NbDiam, 3) = Map_Level(i, j)
    Diams(NbDiam, 4) = 0
    Diams(NbDiam, 5) = 0
    Diams(NbDiam, 6) = Map_Level(i, j - 1)
    Diams(NbDiam, 7) = Map_Level(i + 1, j - 1)
    Diams(NbDiam, 8) = Map_Level(i + 1, j)
    Diams(NbDiam, 9) = Map_Level(i + 1, j + 1)
    Diams(NbDiam, 10) = Map_Level(i, j + 1)
    Diams(NbDiam, 11) = Map_Level(i - 1, j + 1)
    Diams(NbDiam, 12) = Map_Level(i - 1, j)
    Diams(NbDiam, 13) = Map_Level(i - 1, j - 1)
   EndIf
  Next j
 Next i
End Sub

Sub Init_Hero
 'Initialise the Hero status at start from level
 Local i, j, k
 For i = 1 To Level_W
  For j = 1 To Level_H
   'we test if we found the Hero here
   If Map_Level(i, j) = HeroCase Then
    'We got the Hero
    Hero(1) = i
    Hero(2) = j
    Hero(3) = Hero_dont_move
    Hero(4) = 5
    Hero(6) = Map_Level(i, j - 1)
    Hero(7) = Map_Level(i + 1, j)
    Hero(8) = Map_Level(i, j + 1)
    Hero(9) = Map_Level(i - 1, j)
   EndIf
  Next j
 Next i
End Sub

Sub Init_Monster
 'Initialise the Monsters status at start from level
 Local i, j, k, Monster
 NbMonsters = 0
 For i = 1 To Level_W
  For j = 1 To Level_H
   'we test if we found the Monster here
   If (Map_Level(i, j) >= Monster1Pic(1)) And (Map_Level(i, j) <= Monster2Pic(MaxMonsterPic)) Then
    'We got a monster
    NbMonsters = NbMonsters + 1
    Monsters(NbMonsters, 1) = i
    Monsters(NbMonsters, 2) = j
    If (Map_Level(i, j) >= Monster1Pic(1)) And (Map_Level(i, j) <= Monster1Pic(MaxMonsterPic)) Then
     Monsters(NbMonsters, 5) = Monster_Type_1
     Monsters(NbMonsters, 3) = Monster_Type_1
    Else
     Monsters(NbMonsters, 5) = Monster_Type_2
     Monsters(NbMonsters, 3) = Monster_Type_2
    EndIf
    Monsters(NbMonsters, 4) = 5
    Monsters(NbMonsters, 6) = Map_Level(i, j - 1)
    Monsters(NbMonsters, 7) = Map_Level(i + 1, j)
    Monsters(NbMonsters, 8) = Map_Level(i, j + 1)
    Monsters(NbMonsters, 9) = Map_Level(i - 1, j)
   EndIf
  Next j
 Next i
End Sub

Sub Hero_Move(newd)
 ' Move the Hero and look for collision with
 ' wall , Rocks , etc ....
 Local i
 Local foundrock
 Local foundwall
 Local oldx, oldy, oldd
 Local newx, newy
 oldx = Hero(1)
 oldy = Hero(2)
 oldd = Hero(4)
 foundrock = 0
 foundwall = 0
 'up
 If newd = 1 Then
  newx = Hero(1)
  newy = Hero(2) - 1
 EndIf
 'right
 If newd = 2 Then
  newx = Hero(1) + 1
  newy = Hero(2)
 EndIf
 'down
 If newd = 3 Then
  newx = Hero(1)
  newy = Hero(2) + 1
 EndIf
 'left
 If newd = 4 Then
  newx = Hero(1) - 1
  newy = Hero(2)
 EndIf
 ' check for Rocks
 For i = 1 To NbRocks
  If ((Rocks(i, 1) = newx) And (Rocks(i, 2) = newy)) Then foundrock = i
 Next i
 'If a rock is found , check if we can puch it away
 If foundrock <> 0 Then
  Rescan_Rocks
  If (newd = 2) And (Rocks(foundrock, 8) = BlankCase) Then
   Print @((Rocks(foundrock, 1) - 1) * Sprite_W, (Rocks(foundrock, 2) - 1) * Sprite_H) Chr$(BlankCase)
   Rocks(foundrock, 1) = Rocks(foundrock, 1) + 1
   Print @((Rocks(foundrock, 1) - 1) * Sprite_W, (Rocks(foundrock, 2) - 1) * Sprite_H) Chr$(Rocks(foundrock, 3))
   foundrock = 0
  EndIf
  If foundrock <> 0 Then
   If (newd = 4) And (Rocks(foundrock, 12) = BlankCase) Then
    Print @((Rocks(foundrock, 1) - 1) * Sprite_W, (Rocks(foundrock, 2) - 1) * Sprite_H) Chr$(BlankCase)
    Rocks(foundrock, 1) = Rocks(foundrock, 1) - 1
    Print @((Rocks(foundrock, 1) - 1) * Sprite_W, (Rocks(foundrock, 2) - 1) * Sprite_H) Chr$(Rocks(foundrock, 3))
   EndIf
  EndIf
 EndIf
 'check for wall & Rock
 If ((Map_Level(newx, newy) >= WallPic(1)) And (Map_Level(newx, newy) <= WallPic(MaxWallPic))) Then
  foundwall = 1
 EndIf
 If ((Map_Level(newx, newy) >= DiamPic(1)) And (Map_Level(newx, newy) <= DiamPic(MaxDiamPic))) Then
  Score = Score + 10
 EndIf
 'check if we can move
 If ((foundrock = 0) And (foundwall = 0)) Then
  Hero(1) = newx
  Hero(2) = newy
  Hero(4) = newd
  'We have to choose the right Hero Sprite
  If Hero(4) = oldd Then
   If newd = 1 Then
    If (Hero(3) + 1) > Hero_go_up(MaxDirectionPic) Then
     Hero(3) = Hero_go_up(1)
    Else
     Hero(3) = Hero(3) + 1
    EndIf
   EndIf
   If newd = 2 Then
    If (Hero(3) + 1) > Hero_go_right(MaxDirectionPic) Then
     Hero(3) = Hero_go_right(1)
    EndIf
   Else
    Hero(3) = Hero(3) + 1
   EndIf
   If newd = 3 Then
    If (Hero(3) + 1) > Hero_go_down(MaxDirectionPic) Then
     Hero(3) = Hero_go_down(1)
    EndIf
   Else
    Hero(3) = Hero(3) + 1
   EndIf
   If newd = 4 Then
    If (Hero(3) + 1) > Hero_go_left(MaxDirectionPic) Then
     Hero(3) = Hero_go_left(1)
    EndIf
   Else
    Hero(3) = Hero(3) + 1
   EndIf
  Else
   If newd = 1 Then
    Hero(3) = Hero_go_up(1)
   EndIf
   If newd = 2 Then
    Hero(3) = Hero_go_right(1)
   EndIf
   If newd = 3 Then
    Hero(3) = Hero_go_down(1)
   EndIf
   If newd = 4 Then
    Hero(3) = Hero_go_left(1)
   EndIf
  EndIf
  Sound 200 , 50
 EndIf
 ' Delete the actual Hero position
 Print @((oldx - 1) * Sprite_W, (oldy - 1) * Sprite_H) Chr$(BlankCase)
 ' Draw the Hero at new position
 Print @((Hero(1) - 1) * Sprite_W, (Hero(2) - 1) * Sprite_H) Chr$(Hero(3))
 Map_Level(oldx, oldy) = BlankCase
 Map_Level(Hero(1), Hero(2)) = HeroCase
 Init_Diamonds
 If NbDiam = 0 Then
  Level_Number = Level_Number + 1
  If Number >= 100 Then MapFile$ = "lvl_" + Str$(Level_Number) + ".lvl"
  If Number < 100 Then MapFile$ = "lvl_0" + Str$(Level_Number) + ".lvl"
  If Number < 10 Then MapFile$ = "lvl_00" + Str$(Level_Number) + ".lvl"
  If (Level_Number <= MaxLevel) Then
   Read_Map_File MapFile$
   Show_Map
   Init_Rocks
   Init_Diamonds
   Init_Hero
   Init_Monster
   Hero(5) = Hero(5) + 1
  Else
   Level_Number = 1
   MapFile$ = "lvl_001.lvl"
   Read_Map_File MapFile$
   Show_Map
   Init_Rocks
   Init_Diamonds
   Init_Hero
   Init_Monster
   Hero(5) = 3
  EndIf
 EndIf
End Sub

Sub Show_Map
 'Show the loaded map
 Local CntX, CntY
 For CntY = 1 To Level_H
  For CntX = 1 To Level_W
   If (Map_Level(CntX, CntY) > 64) And (Map_Level(CntX, CntY) < 110) Then
    Print @((CntX - 1) * Sprite_W, (CntY - 1) * Sprite_H) Chr$(Map_Level(CntX, CntY))
   Else
    If Map_Level(CntX, CntY) >= 110 Then
     Map_Level(CntX, CntY) = BlankCase
     Print @((CntX - 1) * Sprite_W, (CntY - 1) * Sprite_H) Chr$(Map_Level(CntX, CntY))
    EndIf
    If Map_Level(CntX, CntY) <= 64 Then
     Map_Level(CntX, CntY) = HeroCase
     Hero(3) = 41
     Print @((CntX - 1) * Sprite_W, (CntY - 1) * Sprite_H) Chr$(Hero(3))
    EndIf
   EndIf
  Next CntX
 Next CntY
End Sub

Sub Hero_Killed
 'The Hero die
 'We decrement the Lives number and set the Hero position to
 'The original Start position.
 Lives = Lives - 1
 Sound 100 , 200
 If Lives = 0 Then
  'Game Over
  Font #2
  Print @(180,190,2) "GAME OVER"
  Font #1
  End
 EndIf
 Map_Level(Hero(1), Hero(2)) = BlankCase
 Print @((Hero(1) - 1) * Sprite_W , (Hero(2) - 1) * Sprite_H) Chr$(BlankCase)
 Hero(1) = HeroStart(1)
 Hero(2) = HeroStart(2)
 Hero(3) = 41
 Map_Level(HeroStart(1), HeroStart(2)) = Hero(3)
 Print @((Hero(1) - 1) * Sprite_W, (Hero(2) - 1) * Sprite_H) Chr$(Hero(3))
 Init_Hero
End Sub

Sub Monster_Move( Monster_Num )
 'Move the Monsters
 'Here we look if it's something who can block the monster
 Rescan_Monsters ( Monster_Num )
 'up
 If Monsters(Monster_Num, 4) = 1 Then
  If (Monsters(Monster_Num, 6) = BlankCase) Or (Monsters(Monster_Num, 6) = HeroCase) Then
   Monsters(Monster_Num, 2) = Monsters(Monster_Num, 2) - 1
  Else
   Monsters(Monster_Num, 4) = 5
  EndIf
 EndIf
 'right
 If Monsters(Monster_Num, 4) = 2 Then
  If (Monsters(Monster_Num, 7) = BlankCase) Or (Monsters(Monster_Num, 7) = HeroCase) Then
   Monsters(Monster_Num, 1) = Monsters(Monster_Num, 1) + 1
  Else
   Monsters(Monster_Num, 4) = 5
  EndIf
 EndIf
 'down
 If Monsters(Monster_Num, 4) = 3 Then
  If (Monsters(Monster_Num, 8) = BlankCase) Or (Monsters(Monster_Num, 8) = HeroCase) Then
   Monsters(Monster_Num, 2) = Monsters(Monster_Num, 2) + 1
  Else
   Monsters(Monster_Num, 4) = 5
  EndIf
 EndIf
 'left
 If Monsters(Monster_Num, 4) = 4 Then
  If (Monsters(Monster_Num, 9) = BlankCase) Or (Monsters(Monster_Num, 9) = HeroCase) Then
   Monsters(Monster_Num, 1) = Monsters(Monster_Num, 1) - 1
  Else
   Monsters(Monster_Num, 4) = 5
  EndIf
 EndIf
 'Cannot move to the actual direction , we look for another direction
 If Monsters(Monster_Num, 4) = 5 Then
  'test up
  If (Monsters(Monster_Num, 6) = BlankCase) Or (Monsters(Monster_Num, 6) = HeroCase) Then
   Monsters(Monster_Num, 4) = 1
   Monsters(Monster_Num, 2) = Monsters(Monster_Num, 2) - 1
   Exit Sub
  EndIf
  'test right
  If (Monsters(Monster_Num, 7) = BlankCase) Or (Monsters(Monster_Num, 7) = HeroCase) Then
   Monsters(Monster_Num, 4) = 2
   Monsters(Monster_Num, 1) = Monsters(Monster_Num, 1) + 1
   Exit Sub
  EndIf
  'test down
  If (Monsters(Monster_Num, 8) = BlankCase) Or (Monsters(Monster_Num, 8) = HeroCase) Then
   Monsters(Monster_Num, 4) = 3
   Monsters(Monster_Num, 2) = Monsters(Monster_Num, 2) + 1
   Exit Sub
  EndIf
  'test left
  If (Monsters(Monster_Num, 9) = BlankCase) Or (Monsters(Monster_Num, 9) = HeroCase) Then
   Monsters(Monster_Num, 4) = 4
   Monsters(Monster_Num, 1) = Monsters(Monster_Num, 1) - 1
   Exit Sub
  EndIf
 EndIf
End Sub

Sub Show_Explosion( ExpNum )
 ExplodeCoords(ExpNum, 3) = ExplodeCoords(ExpNum, 3) + 1
 If ExplodeCoords(ExpNum, 3) <= ExploPic(MaxExploPic) Then
  'We increment the explosion pictures
  Map_Level(ExplodeCoords(ExpNum, 1), ExplodeCoords(ExpNum, 2)) = ExplodeCoords(ExpNum, 3)
  Map_Level(ExplodeCoords(ExpNum, 1), ExplodeCoords(ExpNum, 2) + 1) = ExplodeCoords(ExpNum, 3)
  Map_Level(ExplodeCoords(ExpNum, 1) + 1, ExplodeCoords(ExpNum, 2) + 1) = ExplodeCoords(ExpNum, 3)
  Map_Level(ExplodeCoords(ExpNum, 1) + 1, ExplodeCoords(ExpNum, 2)) = ExplodeCoords(ExpNum, 3)
  Map_Level(ExplodeCoords(ExpNum, 1) + 1, ExplodeCoords(ExpNum, 2) - 1) = ExplodeCoords(ExpNum, 3)
  Map_Level(ExplodeCoords(ExpNum, 1), ExplodeCoords(ExpNum, 2) - 1) = ExplodeCoords(ExpNum, 3)
  Map_Level(ExplodeCoords(ExpNum, 1) - 1, ExplodeCoords(ExpNum, 2) - 1) = ExplodeCoords(ExpNum, 3)
  Map_Level(ExplodeCoords(ExpNum, 1) - 1, ExplodeCoords(ExpNum, 2)) = ExplodeCoords(ExpNum, 3)
  Map_Level(ExplodeCoords(ExpNum, 1) - 1, ExplodeCoords(ExpNum, 2) + 1) = ExplodeCoords(ExpNum, 3)
 Else
  'Explosion is finish , we can add the diamonds
  ExplodeCoords(ExpNum, 3) = 0
  Map_Level(ExplodeCoords(ExpNum, 1), ExplodeCoords(ExpNum, 2)) = DiamPic(1)
  Map_Level(ExplodeCoords(ExpNum, 1), ExplodeCoords(ExpNum, 2) + 1) = DiamPic(1)
  Map_Level(ExplodeCoords(ExpNum, 1) + 1, ExplodeCoords(ExpNum, 2) + 1) = DiamPic(1)
  Map_Level(ExplodeCoords(ExpNum, 1) + 1, ExplodeCoords(ExpNum, 2)) = DiamPic(1)
  Map_Level(ExplodeCoords(ExpNum, 1) + 1, ExplodeCoords(ExpNum, 2) - 1) = DiamPic(1)
  Map_Level(ExplodeCoords(ExpNum, 1), ExplodeCoords(ExpNum, 2) - 1) = DiamPic(1)
  Map_Level(ExplodeCoords(ExpNum, 1) - 1, ExplodeCoords(ExpNum, 2) - 1) = DiamPic(1)
  Map_Level(ExplodeCoords(ExpNum, 1) - 1, ExplodeCoords(ExpNum, 2)) = DiamPic(1)
  Map_Level(ExplodeCoords(ExpNum, 1) - 1, ExplodeCoords(ExpNum, 2) + 1) = DiamPic(1)
  Explode_End ExplodeCoords(ExpNum, 1), ExplodeCoords(ExpNum, 2)
  Pose_Dynamite = 0
 EndIf
 Print @((ExplodeCoords(ExpNum, 1) - 1) * Sprite_W, (ExplodeCoords(ExpNum, 2) - 1) * Sprite_H) Chr$(Map_Level(ExplodeCoords(ExpNum, 1), ExplodeCoords(ExpNum, 2)))
 Print @((ExplodeCoords(ExpNum, 1) - 1) * Sprite_W, (ExplodeCoords(ExpNum, 2)) * Sprite_H) Chr$(Map_Level(ExplodeCoords(ExpNum, 1), ExplodeCoords(ExpNum, 2) + 1))
 Print @((ExplodeCoords(ExpNum, 1)) * Sprite_W, (ExplodeCoords(ExpNum, 2)) * Sprite_H) Chr$(Map_Level(ExplodeCoords(ExpNum, 1) + 1, ExplodeCoords(ExpNum, 2) + 1))
 Print @((ExplodeCoords(ExpNum, 1)) * Sprite_W, (ExplodeCoords(ExpNum, 2) - 1) * Sprite_H) Chr$(Map_Level(ExplodeCoords(ExpNum, 1) + 1, ExplodeCoords(ExpNum, 2)))
 Print @((ExplodeCoords(ExpNum, 1)) * Sprite_W, (ExplodeCoords(ExpNum, 2) - 2) * Sprite_H) Chr$(Map_Level(ExplodeCoords(ExpNum, 1) + 1, ExplodeCoords(ExpNum, 2) - 1))
 Print @((ExplodeCoords(ExpNum, 1) - 1) * Sprite_W, (ExplodeCoords(ExpNum, 2) - 2) * Sprite_H) Chr$(Map_Level(ExplodeCoords(ExpNum, 1), ExplodeCoords(ExpNum, 2) - 1))
 Print @((ExplodeCoords(ExpNum, 1) - 2) * Sprite_W, (ExplodeCoords(ExpNum, 2) - 2) * Sprite_H) Chr$(Map_Level(ExplodeCoords(ExpNum, 1) - 1, ExplodeCoords(ExpNum, 2) - 1))
 Print @((ExplodeCoords(ExpNum, 1) - 2) * Sprite_W, (ExplodeCoords(ExpNum, 2) - 1) * Sprite_H) Chr$(Map_Level(ExplodeCoords(ExpNum, 1) - 1, ExplodeCoords(ExpNum, 2)))
 Print @((ExplodeCoords(ExpNum, 1) - 2) * Sprite_W, (ExplodeCoords(ExpNum, 2)) * Sprite_H) Chr$(Map_Level(ExplodeCoords(ExpNum, 1) - 1, ExplodeCoords(ExpNum, 2) + 1))
 'Test if the hero die in explosion
 If (Hero(1) >= (ExplodeCoords(ExpNum, 1) - 1)) And (Hero(1) <= (ExplodeCoords(ExpNum, 1) + 1)) Then
  If (Hero(2) >= (ExplodeCoords(ExpNum, 2) - 1)) And (Hero(2) <= (ExplodeCoords(ExpNum, 2) + 1)) Then
   Hero_Killed
  EndIf
 EndIf
End Sub

Sub Check_Monster_Status
 'Here we check if a monster have to die
 Local m
 Local ExpCnt

 For m = 1 To NbMonsters
  If (Monsters(m, 6) >= 65) And (Monsters(m, 6) <= 72) Then
   'Block or Diamond fall on Monster he have to die
   Map_Level(Monsters(m, 1), Monsters(m, 2)) = ExploPic(1)
   Sound 700 , 50
   Print  @((Monsters(m, 1) - 1)* Sprite_W, (Monsters(m, 2) - 1)* Sprite_H) Chr$(ExploPic(1))
   For ExpCnt = 1 To 5
    If ExplodeCoords(ExpCnt, 3) = 0 Then
     ExplodeCoords(ExpCnt, 1) = Monsters(m, 1)
     ExplodeCoords(ExpCnt, 2) = Monsters(m, 2)
     ExplodeCoords(ExpCnt, 3) = ExploPic(1)
     Init_Monster
     ExpCnt = 100
    EndIf
   Next ExpCnt
  EndIf
 Next m
End Sub

Sub Explode_End( Exp_X , Exp_Y )
 'We redraw the delimiting wall when the explosion destroyed one
 If (Exp_X <= 2) Or (Exp_X > (Level_W - 2)) Or (Exp_Y <= 2) Or (Exp_Y > (Level_H - 2)) Then
  If Exp_X <= 2 Then
   Print @(0, (Exp_Y - 2) * Sprite_H) Chr$(WallPic(1))
   Print @(0, (Exp_Y - 1) * Sprite_H) Chr$(WallPic(1))
   Print @(0, Exp_Y * Sprite_H) Chr$(WallPic(1))
   Map_Level(1, Exp_Y - 1) = WallPic(1)
   Map_Level(1, Exp_Y) = WallPic(1)
   Map_Level(1, Exp_Y + 1) = WallPic(1)
  EndIf
  If Exp_X > (Level_W - 2) Then
   Print @((Level_W - 1) * Sprite_W, (Exp_Y - 2) * Sprite_H) Chr$(WallPic(1))
   Print @((Level_W - 1) * Sprite_W, (Exp_Y - 1) * Sprite_H) Chr$(WallPic(1))
   Print @((Level_W - 1) * Sprite_W, Exp_Y * Sprite_H) Chr$(WallPic(1))
   Map_Level(Level_W, Exp_Y - 1) = WallPic(1)
   Map_Level(Level_W, Exp_Y) = WallPic(1)
   Map_Level(Level_W, Exp_Y + 1) = WallPic(1)
  EndIf
  If Exp_Y <= 2 Then
   Print @((Exp_X - 2) * Sprite_W, 0) Chr$(WallPic(1))
   Print @((Exp_X - 1) * Sprite_W, 0) Chr$(WallPic(1))
   Print @(Exp_X * Sprite_W, 0) Chr$(WallPic(1))
   Map_Level(Exp_X - 1, 1) = WallPic(1)
   Map_Level(Exp_X, 1) = WallPic(1)
   Map_Level(Exp_X + 1, 1) = WallPic(1)
  EndIf
  If Exp_Y > (Level_H - 2) Then
   Print @((Exp_X - 2) * Sprite_W, (Level_H - 1) * Sprite_H) Chr$(WallPic(1))
   Print @((Exp_X - 1) * Sprite_W, (Level_H - 1) * Sprite_H) Chr$(WallPic(1))
   Print @(Exp_X * Sprite_W, (Level_H - 1) * Sprite_H) Chr$(WallPic(1))
   Map_Level(Exp_X - 1, Level_H) = WallPic(1)
   Map_Level(Exp_X, Level_H) = WallPic(1)
   Map_Level(Exp_X + 1, Level_H) = WallPic(1)
  EndIf
 EndIf
 Init_Rocks
 Init_Diamonds
End Sub

Sub Dynamite
 Local ExpCnt
 'Show the dynamite before explosion
 DynCoord(3) = DynCoord(3) + 1
 If DynCoord(3) > DynamPic(MaxDynamPic) Then
  'The dynamite explode
  For ExpCnt = 1 To 5
   If ExplodeCoords(ExpCnt, 3) = 0 Then
    ExplodeCoords(ExpCnt, 1) = DynCoord(1)
    ExplodeCoords(ExpCnt, 2) = DynCoord(2)
    ExplodeCoords(ExpCnt, 3) = ExploPic(1)
    ExpCnt = 100
   EndIf
  Next ExpCnt
  Exit Sub
 EndIf
 'Show the dynamite
 Print @((DynCoord(1) - 1) * Sprite_W, (DynCoord(2) - 1) * Sprite_H) Chr$(DynCoord(3))
 Map_Level(DynCoord(1), DynCoord(2)) = DynCoord(3)
End Sub

Sub Set_Control
 Local CtrlSelect$
 Cls
 Print @(177,120,2)"CONTROLLER CONFIGURATION"
 Print @(165,150)"[1] - Joystick"
 Print @(165,170)"[2] - Nunchuk"
 Print @(165,190)"[3] - Keyboard"
 CtrlSelect$ = ""
 Do While (CtrlSelect$ <> "1") And (CtrlSelect$ <> "2") And (CtrlSelect$ <> "3")
  CtrlSelect$ = Inkey$
 Loop
 If CtrlSelect$ = "1" Then
  Joystick = 1
  ' Joystick PIN's definition
  'PIN 11 = UP
  SetPin 11,2
  'PIN 12 = DOWN
  SetPin 12,2
  'PIN 13 = LEFT
  SetPin 13,2
  'PIN 14 = RIGHT
  SetPin 14,2
  'PIN 15 = Button 1
  SetPin 15,2
  'PIN 16 = Button 2
  SetPin 16,2
 EndIf
 If CtrlSelect$ = "2" Then
  Nunchuck = 1
  'Enable I2C
  I2CEN 400, 100
  'Init Nunchuck
  I2CSEND i2caddr, 0, 2, &hF0, &h55
  I2CSEND i2caddr, 0, 2, &hFB, &h0
  Pause 200
  I2CSEND i2caddr, 0, 1, &h0
  I2CRCV i2caddr, 0, 6, RDBuff(0)
  Pause 200
 EndIf
 If CtrlSelect$ = "3" Then
  Keyboard = 1
 EndIf
End Sub

Sub Joystick_Ctrl
 If Pin(11) = 0 Then ActKey = &h80
 If Pin(12) = 0 Then ActKey = &h81
 If Pin(13) = 0 Then ActKey = &h82
 If Pin(14) = 0 Then ActKey = &h83
 If Pin(15) = 0 Then ActKey = 32
End Sub

Sub Nunchuck_Ctrl
 I2CSEND i2caddr, 0, 1, &h0
 I2CRCV i2caddr, 0, 6, RDBuff(0)
 If RDBuff(0)<85 Then ActKey = &h82
 If RDBuff(0)>170 Then ActKey = &h83
 If RDBuff(1)>170 Then ActKey = &h80
 If RDBuff(1)<85 Then ActKey = &h81
 If (RDBuff(5) And &h02) = 0 Then ActKey = 32
End Sub

Sub Keyboard_Ctrl
 Kbd$ = Inkey$
 ActKey = Asc(kbd$)
End Sub
